const sql = require('mssql')
let environment = require('../modules/environment')

async function database(){
    let error = false
    let config = environment.params

    return new Promise( (resolve, reject) => {

        let serverParameter;
        if (config.connection.instance){
            serverParameter = config.connection.host+'\\'+config.connection.instance;
        } else {
            serverParameter = config.connection.host
        }

        let connection =  sql.connect({
            server: serverParameter,
            user: config.connection.user,
            password: config.connection.password,
            database: config.connection.database,
            options: {
                enableArithAbort: false
            }
        })
        .then( ( connection ) => {
            let execute = async (query, params) => {
                let conn = connection;
                let myQuery = query;


                let waitForConnection = async function(attemp = 1){
                    if(!connection._connected){
                        return setTimeout( async _ => {
                            console.log('Tentativa ', attemp)
                            return attemp == 10 ? 'Não foi possível conectar ao sql verver' : waitForConnection(attemp++)
                        }, 1000)
                    } else {
                        if( attemp > 1){
                            console.log('Conectado ao sql server')
                        }                    
                    }
                }

                let wait = await waitForConnection();

                Object.keys(params).forEach( key => {
                    if( typeof(params[key]) == 'string') {
                        myQuery = myQuery.replace(':'+key, '\''+params[key]+'\'')
                    } else {
                        myQuery = myQuery.replace(':'+key, params[key])
                    }
                })
                return conn.query(myQuery);
            }

            let waitForConnection = function(attemp = 1){
                if(!connection._connected){
                    setTimeout( _ => {
                        console.log('Tentativa ', attemp)
                        return attemp == 10 ? reject('Não foi possível estabelecer uma conexão com o banco de dados, verifique usuário, senha e endereço do servidor.') : waitForConnection(attemp++)
                    }, 1000)
                } else {
                    if(attemp > 1){
                        console.log('Conectado ao sql server', attemp)
                    }
                    resolve( {connection, execute })
                }
            }

            let trytoConnect = waitForConnection();

        

        }).catch( error => {
            if(!!error){
                reject('Não foi possível estabelecer uma conexão com o banco de dados, verifique usuário, senha e endereço do servidor.')
                console.log('Não foi possível estabelecer uma conexão com o banco de dados, verifique usuário, senha e endereço do servidor')
                process.exit()
            }
        })

        return connection;
    })
}

module.exports = database;