const database = process.database
const utilities = require('../utils/utilities')
query = require('./query')()

let interval = 1000

/** Carregar o updater */
let updater = require('../modules/updater')

/** Carregar o environment */
let environment = require('../modules/environment')

async function run(socket){
        
        let {connection, execute } = await require('./database')()        

        do {
            try {
                
                deleteExceededOrders()
                getOrdersOnProduction()
                getOrdersToCall()
                await utilities.sleep(interval)

            } catch (error) {
                console.log(error)
                await utilities.sleep(interval)
            }
        } while (true)

        //Pega pedidos em produção
        async function getOrdersOnProduction(){
            let ordersParams = {}
            ordersParams['CDLOJA'] = environment.identification.cdloja;

            let getOrdersQuery;
            let storeParams = {
                'CDFILIAL': environment.identification.cdfilial,
                'CDLOJA': environment.identification.cdloja
            }

            let result = await execute( query.getParamIDCONDPEDPAG, storeParams );
            let condicionaPedidoAoPagamento = result.recordset[0].IDCONDPEDPAG;

            if (condicionaPedidoAoPagamento === 'S'){
                // Traz apenas as ordens que já foram pagas e estao em producao no KDS
                getOrdersQuery = query.getPaidOrdersOnProduction;
            } else {
                // Traz todas as ordens que estao em producao no KDS, independente da situacao do pagamento
                getOrdersQuery = query.getOrdersOnProduction;
            }

            execute( getOrdersQuery, ordersParams )
            .then(data => {
                updater.updateDoing(data.recordset)
            })
        }

        function getOrdersToCall(){
            let params = {}
            params['CDLOJA'] = environment.identification.cdloja;

            execute( query.getOrdersToCall, params )
            .then(data => {
                //Pega pedidos prontos
                updater.updateDone(data.recordset)
            })
        }

        function deleteExceededOrders(){
            let params = {}
            params['EXPIRE'] = environment.config.expire;
            params['CDLOJA'] = environment.identification.cdloja;
            execute(query.deleteExceededRegistry, params)
        }
}

module.exports =  run